function love.load()
    flechas = {}
    
    flechaStatics = love.graphics.newImage("Image/Flecha.png")
    sound_Flecha = love.audio.newSource("Sound/s_0.mp3")
    x = 0
    y = 300
    angle = 190
    direction = 0
    
    insertFlecha = false
    timeShot = 40
    countShot = timeShot
end

function love.update(dt)
    countShot = countShot + 1
    --direction = math.atan2(love.mouse.getX()-x,y-love.mouse.getY())-math.pi/2
    direction = math.atan2(angle-x,y-angle)-math.pi / 3
    MoveFlecha(dt)
    
    -- Mueve la flecha a la direccion marcada.
    if love.keyboard.isDown("up") then
       MoveFlechaKeyBoard("up")
    elseif love.keyboard.isDown("down") then
       MoveFlechaKeyBoard("down")
    end
   
    if angle >= 285 then
       angle = 285 
    elseif angle <= -175 then
       angle = -175
    end
    
    RemoveShoutAllTop()
    
    if insertFlecha == true then
       if countShot >= timeShot then
          InsertArpon()
          countShot = 0
       end
    end
    GravityFlecha(dt)
end

function love.draw()
    for i,v in ipairs(flechas) do
       love.graphics.draw(v.image,v.x,v.y,v.angle,1,1) 
    end
    
    love.graphics.draw(flechaStatics, x, y, direction, 1, 1)
    
    love.graphics.print("Angle: " .. angle .. "\n" .. "X: " .. x .. " Y: " .. y,0,0)
    
    love.graphics.print("FPS: " .. tostring(love.timer.getFPS()),0,30)
end

function MoveFlechaKeyBoard(key)
   if key == "up" then
       angle = angle - 5
   elseif key == "down" then
       angle = angle + 5
   end
end

function love.keypressed(key)
   if key == "q" then
      --InsertArpon()
      insertFlecha = true 
   elseif key == "e" then
      insertFlecha = false
   end  
end

function InsertArpon()
    flecha = {}
    
    flecha.image = love.graphics.newImage("Image/Flecha.png")
    flecha.x = 0
    flecha.y = 300
    flecha.w = flecha.image:getWidth()
    flecha.h = flecha.image:getHeight()
    flecha.speed = 200
    flecha.angle = direction
    flecha.gravity = 0.2
    
    table.insert(flechas,flecha)
end

--Ship.Position.x = Ship.Position.x+(math.cos(Ship.Direction)*dt*ShipSpeed)
--Ship.Position.y = Ship.Position.y+(math.sin(Ship.Direction)*dt*ShipSpeed)
--Ship.Direction = math.atan2(love.mouse.getX()-Ship.Position.x,Ship.Position.y-love.mouse.getY())-math.pi/2

function MoveFlecha(dt)
    for i,v in ipairs(flechas) do
       v.x = v.x + (math.cos(v.angle)*v.speed*dt)
       v.y = v.y + (math.sin(v.angle)*v.speed*dt)
    end
end

function RemoveShoutAllTop()
    local remShot = {}
    
    for i,v in ipairs(flechas) do
        if (v.x >= 800) or (v.y >= 550) then
            table.insert(remShot, i)
        end
    end
    
    for i,v in ipairs(remShot) do
        table.remove(flechas, v)
    end
end

function GravityFlecha(dt)
    for i,v in ipairs(flechas) do
        if v.angle <= 0.8 then
            v.angle = v.angle + 0.2 * dt
        elseif v.angle <= 0.9 then
           v.angle = v.angle + 0.2 * dt
       end
    end
end

-- Function para verificar si se produce alguna colipcion.
function IsCollider(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end







